#Module-Specific definitions
%define mod_name mod_python
%define mod_conf 16_%{mod_name}.conf
%define mod_so %{mod_name}.so

Summary:	An embedded Python interpreter for the apache web server
Name:		apache-%{mod_name}
Version:	3.3.1
Release:	%mkrel 2
Group:		System/Servers
License:	Apache License
URL:		http://www.modpython.org/
Source0:	http://www.apache.org/dist/httpd/modpython/%{mod_name}-%{version}.tgz
Source1:	http://www.apache.org/dist/httpd/modpython/%{mod_name}-%{version}.tgz.asc
Source2:	%{mod_conf}
Source3:	mod_python-manual.conf
Patch0:		mod_python-3.0.3-version.patch
Patch1:		mod_python-20020610-gsr.patch
Patch2:		mod_python-3.1.3-ldflags.patch
Patch3:		mod_python-3.1.4-cflags.patch
BuildRequires:	python
BuildRequires:	python-devel
BuildRequires:	automake1.7
BuildRequires:	autoconf2.5
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.0.54
Requires(pre):	apache >= 2.0.54
Requires:	apache-conf >= 2.0.54
Requires:	apache >= 2.0.54
BuildRequires:  apache-mpm-prefork >= 2.0.54
BuildRequires:  apache-modules >= 2.0.54
BuildRequires:	apache-devel >= 2.0.54
BuildRequires:	file
BuildRequires:	flex >= 2.5.33
Provides:	mod_python apache2-mod_python
Obsoletes:	mod_python apache2-mod_python
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Mod_python is a module that embeds the Python language interpreter within
the apache server, allowing Apache handlers to be written in Python.

Mod_python brings together the versatility of Python and the power of
the Apache Web server for a considerable boost in flexibility and
performance over the traditional CGI approach.

%package	doc
Summary:	Online html documentation for mod_python
Group:		System/Servers
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.0.54
Requires(pre):	apache >= 2.0.54

%description	doc
This package contains the mod_python manual in the html format.

You can view the documentation by using this URL:

http://localhost/manual/mod/mod_python

%prep

%setup -q -n %{mod_name}-%{version}
%patch0 -p0
%patch1 -p0 -b .gsr
%patch2 -p1 -b .ldflags
%patch3 -p1 -b .cflags

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -r $i; fi >&/dev/null
done

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find . -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

cp %{SOURCE2} %{mod_conf}
cp %{SOURCE3} mod_python-manual.conf

%build
export WANT_AUTOCONF_2_5=1
rm -f configure
libtoolize --copy --force; aclocal-1.7; autoconf --force

export HTTPD="%{_sbindir}/httpd"

%configure2_5x \
    --with-apxs=%{_sbindir}/apxs \
    --with-max-locks=4 \
    --with-mutex-dir=/var/cache/httpd/mod_python \
    --with-flex=%{_bindir}/flex

%make APXS_CFLAGS="-Wc,-fno-strict-aliasing"

#pushd test
#    python test.py
#popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_libdir}/apache-extramodules
install -d %{buildroot}%{_sysconfdir}/httpd/modules.d
install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d

#export EXCLUDE_FROM_STRIP=%{buildroot}%{_libdir}/apache-extramodules/%{mod_so}

%makeinstall_std

# move the module in place
mv %{buildroot}%{_libdir}/apache/%{mod_so} %{buildroot}%{_libdir}/apache-extramodules

install -d %{buildroot}/var/www/html/addon-modules
ln -s ../../../..%{_docdir}/%{name}-%{version} %{buildroot}/var/www/html/addon-modules/%{name}-%{version}

# fix location for mutex files
install -d %{buildroot}/var/cache/httpd/mod_python

# install config files
install -m0644 %{mod_conf} %{buildroot}%{_sysconfdir}/httpd/modules.d/

# it has to be loaded before 00_manual.conf ;)
install -m0644 mod_python-manual.conf %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/000_mod_python.conf

# fix absolute path to docdir
perl -pi -e "s|_REPLACE_ME_|%{_docdir}/%{name}-doc-%{version}|g" %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/*_mod_python.conf

cat > README.mdv << EOF

There is a bundled test suite that is somewhat tricky to use. I will explain how 
to run it here. I will not cover how to setup the proper rpm build environment and
nessesary packages you will have to install or how to do that.

Install the apache-%{mod_name}-%{version}-%{release}.src.rpm package as a non 
root user. Change directory to where the apache-mod_python.spec file is:

cd ~/RPM/SPECS/

and do:

rpm -bb apache-mod_python.spec

Make the /var/cache/httpd/mod_python directory owned by the user (you) who built the 
apache-%{mod_name}-%{version}-%{release} package.

su root; chown you:you /var/cache/httpd/mod_python

Then exit the root shell and change directory to the rpm build dir:

cd ~/RPM/BUILD/apache-%{mod_name}-%{version}/test

and do:

python test.py

All tests should pass.

Remember to reset the permissions on the mutex cache dir so that the apache user
can use it:

su root; chown apache:apache /var/cache/httpd/mod_python

Done.
EOF

%post
if [ -f /var/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%post doc
if [ -f /var/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun doc
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc CREDITS NEWS README* examples test
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_python.conf
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_so}
/var/www/html/addon-modules/*
%{py_platsitedir}/mod_python/
%{py_platsitedir}/*.egg-info
%attr(0755,apache,apache) %dir /var/cache/httpd/mod_python

%files doc
%defattr(-,root,root)
%doc doc-html/*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/*_mod_python.conf


%changelog
* Sat Mar 10 2007 Oden Eriksson <oeriksson@mandriva.com> 3.3.1-2mdv2007.1
+ Revision: 140731
- rebuild

* Thu Feb 15 2007 Oden Eriksson <oeriksson@mandriva.com> 3.3.1-1mdv2007.1
+ Revision: 121295
- 3.3.1 (final)

* Mon Jan 29 2007 Oden Eriksson <oeriksson@mandriva.com> 3.3.1-0mdv2007.1
+ Revision: 115112
- 3.3.1 (test release)
- bunzip config files
- drop one redundant patch

* Tue Dec 19 2006 Nicolas Lécureuil <neoclust@mandriva.org> 3.2.10-5mdv2007.1
+ Revision: 99140
- Fix file list
- Rebuild against new python

  + Michael Scherer <misc@mandriva.org>
    - fix the file list on x86_64
    - Rebuild for new python

* Tue Nov 21 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.10-2mdv2007.1
+ Revision: 86024
- use new system flex
- Import apache-mod_python



* Fri Aug 04 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.10-1mdv2007.0
- 3.2.10

* Thu Jul 20 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.10-0mdv2007.0
- 3.2.10

* Sat Jul 01 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.9-0mdv2007.0
- 3.2.9
- drop the mutex_dir patch, better fix upstream
- drop upstream patches; P9, P10
- renumber the patches
- fix deps

* Tue Feb 21 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.8-2mdk
- ship the *.asc file too and make it rpmbuildupdate friendly
- explain how to run the test suite in the README.mdv file.

* Tue Feb 21 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.8-1mdk
- 3.2.8 final

* Mon Feb 20 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.8-0.1mdk
- 3.2.8 (security fixes)
- better apache-2.2.0 support (P9)
- added P10 to fix build with bash 3.1

* Tue Feb 14 2006 Oden Eriksson <oeriksson@mandriva.com> 3.2.7-1mdk
- 3.2.7
- dropped upstream patches; P4.P6
- added new P9 from HEAD (replaces the apr1 patch)

* Wed Dec 14 2005 Oden Eriksson <oeriksson@mandriva.com> 3.1.4-2mdk
- rebuilt against apache-2.2.0
- sync with fedora (3.1.4-3)
- fix directives and a sub package for the manual

* Mon Nov 28 2005 Oden Eriksson <oeriksson@mandriva.com> 3.1.4-1mdk
- fix versioning

* Mon Oct 10 2005 Nicolas Lcureuil <neoclust@mandriva.org> 2.0.54_3.1.4-3mdk
- Fix BuildRequires

* Sat Jul 30 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_3.1.4-2mdk
- fix deps

* Thu Jun 02 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_3.1.4-1mdk
- rename the package
- the conf.d directory is renamed to modules.d
- use new rpm-4.4.x pre,post magic

* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-4mdk
- use the %%mkrel 1

* Mon Feb 28 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-3mdk
- fix %%post and %%postun to prevent double restarts
- fix bug #6574

* Wed Feb 16 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-2mdk
- spec file cleanups, remove the ADVX-build stuff

* Fri Feb 11 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-1mdk
- rebuilt for apache 2.0.53

* Tue Feb  8 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.3-1mdk
- rebuilt for apache 2.0.53

* Sat Dec 04 2004 Michael Scherer <misc@mandrake.org> 2.0.52_3.1.3-3mdk
- Rebuild for new python

* Sat Nov 27 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_3.1.3-2mdk
- added P4,P5,P6 from fedora
- use the %%configure2_5x macro
- fix deps

* Tue Sep 28 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_3.1.3-1mdk
- built for apache 2.0.52

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.51_3.1.3-1mdk
- built for apache 2.0.51

* Mon Jul 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_3.1.3-1mdk
- built for apache 2.0.50
- remove redundant provides

* Fri Jun 11 2004 Michael Scherer <misc@mandrake.org> 2.0.49_3.1.3-1mdk
- rebuild for new apache
 
* Mon Mar 01 2004 Michael Scherer <misc@mandrake.org> 2.0.48_3.1.3-1mdk 
- 3.1.3
- added a psp config example
- [DIRM]

* Wed Nov 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.48_3.1.2b-1mdk
- built for apache 2.0.48

* Sun Nov 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.1.2b-1mdk
- 3.1.2b
- drop P2 & P4
- fix cache dir

* Tue Sep 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.1.0a-2mdk
- added P4 (may fix #5629)

* Sat Aug 30 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.1.0a-1mdk
- 3.1.0a
- added P2 + buildrequires flex
- added P3 + mutex dir + fixed S2
- new license
- misc spec file fixes

* Thu Aug 07 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-4mdk
- rebuild against new python

* Fri Jul 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-3mdk
- found the problem at last..., the %{mod_so} file won't work stripped...

* Thu Jul 24 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-2mdk
- don't install the compiled stuff in python lib (it's messed up)

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-1mdk
- rebuilt against latest apache2, requires and buildrequires

* Mon Jul 07 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_3.0.3-2mdk
- fix #4140 (P0)

* Sat May 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_3.0.3-1mdk
- rebuilt for apache v2.0.46
- buildprereq ADVX-build >= 9.2

* Tue Apr 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.45_3.0.3-1mdk
- cosmetic rebuild for apache v2.0.45 

* Sun Apr 06 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_3.0.3-1mdk
- 3.0.3
- added the pgp sig file
- fix P0
- misc spec file fixes

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_3.0.1-1mdk
- rebuilt for apache v2.0.44

* Mon Jan 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-4mdk
- fix buildrequires apache-devel >= 2.0.53-1mdk, as 
  pointed out by Olivier Thauvin

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-3mdk
- rebuilt against rebuilt buildrequires

* Mon Jan 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-2mdk
- Rebuilt with the new apache-devel that uses /usr/sbin/apxs2 and
  /usr/include/apache2

* Wed Nov 27 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-1mdk
- new major version
- drop all patches, add P0 (a simple DESTDIR patch)

* Sat Nov 02 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.0-3mdk
- rebuilt for/against apache2 where dependencies has changed in apr

* Tue Oct 22 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.0-2mdk
- extra modules needs to be loaded _before_ mod_ssl, mod_php and mod_perl
  in order to show up in the server string...

* Fri Oct 04 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.0-1mdk
- rebuilt for/against new apache2 version 2.0.43 (even though 2.0.42 and 
  2.0.43 are binary compatible, we have to consider rpm dependencies)
- sanitize rpm package versioning

* Thu Sep 26 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.42_3.0.0-4mdk
- rebuilt against new apache v2.0.42

* Wed Sep  3 2002 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.40ADVX_3.0.0-3mdk
- Obsoletes mod_python

* Wed Sep  3 2002 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.40ADVX_3.0.0-2mdk
- Comply with ADVX policy at http://advx.org/devel/policy.php

* Sun Sep  1 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 3.0.0-1mdk
- initial cooker contrib, ripped from RH, adapted for ML
